﻿package
{
	import flash.display.MovieClip;
	import Card;
	import Boarder;
	import BlueBoard;
	import flash.events.MouseEvent;
	import RedBoard;
	import Snow;
	
	public class MemoryGame extends MovieClip
	{
		private var _card:Card;
		private var _boarder:Boarder;
		private var _blueBoard:BlueBoard;
		private var _cardX:Number;
		private var _cardY:Number;
		private var _firstCard:*;
		private var _totalMatches:Number;
		private var _currentMatches:Number;
		private var _redBoard:RedBoard;
		private var _snow:Snow;
		private var _cards:Array;
		
		public function MemoryGame()
		{
			_cards = new Array();
			_totalMatches = 4;
			_currentMatches = 0;
			createCards();
		}
		
		private function createCards():void
		{
			_cardX = 45;
			_cardY = 31;
			
			for(var i:Number = 0; i < 2; i++)
			{
			_card = new Card();
			addChild(_card);
			_boarder = new Boarder();
			_card.setType(_boarder);
			_card.x = _cardX;
			_card.y = _cardY;
			_cardX += _card.width + 50;
			_card.addEventListener(MouseEvent.CLICK, checkCards);
			_cards.push(_card);
			}
			
			for(var j:Number = 0; j < 2; j++)
			{
			_card = new Card();
			addChild(_card);
			_blueBoard = new BlueBoard();
			_card.setType(_blueBoard);
			_card.x = _cardX;
			_card.y = _cardY;
			_cardX += _card.width + 50;
			_card.addEventListener(MouseEvent.CLICK, checkCards);
			_cards.push(_card);
			}
			_cardX = 45;
			_cardY += _card.height + 50;
			for(var k:Number = 0; k < 2; k++)
			{
			_card = new Card();
			addChild(_card);
			_redBoard = new RedBoard();
			_card.setType(_redBoard);
			_card.x = _cardX;
			_card.y = _cardY;
			_cardX += _card.width + 50;
			_card.addEventListener(MouseEvent.CLICK, checkCards);
			_cards.push(_card);
			}
			
			for(var l:Number = 0; l < 2; l++)
			{
			_card = new Card();
			addChild(_card);
			_snow = new Snow();
			_card.setType(_snow);
			_card.x = _cardX;
			_card.y = _cardY;
			_cardX += _card.width + 50;
			_card.addEventListener(MouseEvent.CLICK, checkCards);
			_cards.push(_card);
			}
			randomizeCards(_cards);
		}
		
		private function checkCards(event:MouseEvent):void
		{
			event.currentTarget.removeEventListener(MouseEvent.CLICK, checkCards);
			
			if(_firstCard == undefined)
			{
				_firstCard = event.currentTarget;
			}
			else if(String(_firstCard._type) == String(event.currentTarget._type))
			{
				trace("match!");
				_firstCard = undefined;
				_currentMatches ++;
				if(_currentMatches >= _totalMatches)
				{
					trace("YOU WIN!!!!!!");
				}
			}
			else
			{
				trace("wrong!");
				_firstCard.gotoAndPlay("flipBack");
				event.currentTarget.gotoAndPlay("flipBack");
				_firstCard.addEventListener(MouseEvent.CLICK, checkCards);
				event.currentTarget.addEventListener(MouseEvent.CLICK, checkCards);
				_firstCard = undefined;
			}
		}
		
		private function randomizeCards(cards:Array):void
		{
			var randomCard1:Number;
			var randomCard2:Number;
			var card1X:Number;
			var card1Y:Number;
			
			for(var i:Number = 0; i < 10; i++)
			{
				randomCard1 = Math.floor(Math.random() * cards.length);
				randomCard2 = Math.floor(Math.random() * cards.length);
				
				card1X = cards[randomCard1].x;
				card1Y = cards[randomCard1].y;
				cards[randomCard1].x = cards[randomCard2].x;
				cards[randomCard1].y = cards[randomCard2].y;
				cards[randomCard2].x = card1X;
				cards[randomCard2].y = card1Y;
			}
		}
	}
}

//public class MemoryGame extends MovieClip: defines the doc class as public so that it can be referenced outside the AS file (the FLA file will link to the AS file)
//public function MemoryGame() - this is the constructor function; this code runs automatically as soon as a new instance of the class is created 

//import flash.display.MovieClip; after referencing a class, you must import it
//import Card; in order to add instances of the Card class within this document class (MemoryGame), we must import the Card class also

//private var _card:Card; - _card variable holds the temporary instance name for each of the cards

//_card = new Card();  creates a new instances of Card to the _card variable
//addChild(_card); dynamically


//starts 9-4
//import Boarder; and import BlueBoard; - imports classes of the graphics created which we exported in the Memory.fla file

//private var _boarder:Boarder; and private var _blueBoard:BlueBoard;
   // _boarder and _blueBoard are placeholders for the instances of boarder and blueBoard
   
//_boarder = new Boarder(); - creates a new instance of Boarder class
//_card.setType(_boarder); -calling the setType in the Card.as file due to it was set to public
   //sets the Card instance (created on line 21) to the data type _boarder (created on line 23)
   //more simply stated - this function allows the boarder to display on the card
   
//starts 9-5
//for(var i:Number = 0; i < 2; i++) - this loop creates multiple instances of the Card class
   //same applies for the j loop on line 37
   // the i loop is for the Boarder instances
   // the j loop is for the BlueBoard instances

//the curly braces on 27 and 35 enclose what was formerly in the createCards function into a for i statement in that function 
   // same applies to 38 and 46 for j loop 
  //lines within these loops positions the cards uniformly
  
//_cardX = 45; and 	_cardY = 31;
   //need to set initial values for X and y before the i and j loops
   //sets the first card 45 pixels from the left side of the Stage and 31 pixels from the top
   
//_card.x = _cardX; and  _card.y = _cardY;
   //sets the card instance's of X and Y properties to the values that _cardX and _cardY variables represents which is 45 and 31
   
//_cardX += _card.width + 50; adds pixels to the X values so that the next card is shifted over and down (or turned over) every time the loops run
   // adds 50 pixels to X so that the cards do not touch;  therefore, the cards will be 50 pixels apart
   
//starts 9-6
//import flash.events.MouseEvent;
    //imports the MouseEvent so that we can add and event listener to every instance we create to detect matches
	// next we need to create variable for each card instance so we can add the event listener
	
//private var _firstCard:*;
   //setting the data type of the first card to a wild card (the * creates a wildcard) since we do not know which card the player will choose first
   //next we should add an event listener
   
//_card.addEventListener(MouseEvent.CLICK, checkCards);
  //adds event listener when mouse is clicked to the _card variable (added to i and j loop)
  
//private function checkCards(event:MouseEvent):void
    // adds an checkCards() event handler that 
	//now it needs to check to see if the card matches the other, so we will use an if statement
	
//lines 55 - 66: the if, else and else statements
	//if(_firstCard == undefined)
		// checks the var _firstCard has a data type yet (if it is undefined)
		//we know it's undefined because we set it as a wildcard on line 16
	//_firstCard = event.currentTarget;
		//now we define the _firstCard as the target of the event listener
		//this will be whatever card the player picks
		//using currentTarget (instead of just target) ensures we capture the event from the card itself (_card)
	//else if(String(_firstCard._type) == String(event.currentTarget._type))
		//else if(String(_firstCard._type) String() changes or converts anything contained within the parentheses to a string 
			//if we would have exclude the String and just typed _firstCard._type, it would produce an instance name
			//this means the _firstCard could be _boarder or _blueboard
		//== String(event.currentTarget._type))
			//checks to see if the string value of the first card's data type which is defined now is equal to the second card's data type
			//if this is true. flash will trace Match Line 61
			//if this is not true, tlash will trace Wrong Lines 63 -66
			
//starts 9-7
//notice the game needs refining from exercise 9-6 because we never reset the _firstCard variable

//Line 59 - _firstCard = event.currentTarget;
	//need to set the value of _firstCard back to undefine because if the statement runs, this means the player has a match
	
//Line 55 - event.currentTarget.removeEventListener(MouseEvent.CLICK, checkCards);
	//removes the event listener (CLICK.event) on the card the event handler is triggered on
	
//starts 9-8
// we now need to check incorrect matches
//line 78 _firstCard.gotoAndPlay("flipBack");
	//Double click on the Card movieclip symbol in the Library of the Memory.fla file
	//the symbol layer has a flipBack symbol that is on Frame 21, this code plays that frame
	//this code only flips back only the first card the player picks, need to add more code which leads to line 79
//Line 79 event.currentTarget.gotoAndPlay("flipBack");
	//allows the other cards to flipBack just as the first card the player picks
	//still a problem when you click the same two cards which leads to the next line of code
//Line 80 _firstCard.addEventListener(MouseEvent.CLICK, checkCards);
	//added the listener back that was removed in line 55 previously to run the handler once again
	
//starts 9-9 Determines a win
//private var _totalMatches:Number; and private var _currentMatches:Number;
	//these two variables are created to eventually hold current Matches and possible matches
//_totalMatches = 2; and  _currentMatches = 0;
	//because there are two snowboarder and two blueboards (two sets of cards), there are two sets of possibilities for matches
	//this is way total matches variable is set to 2
	//since all players starts the game with no matches, current matches is zero
//_currentMatches ++;
	//++ is the operator that adds 1 to a value (for this example it's currentMatches
	//simply put, every time a match is made, the else if statement will run
//if(_currentMatches >= _totalMatches)
	//checks if the currentMatches is greater than the total matches within a nest of the else if statement
	//if this statement runs, YOU WIN will be traced
	
//starts 9-10 Adding more cards
//import RedBoard;  and  import Snow;
	//importing movieclips from Memory.fla which we have exported AS first within the linkage property
	//we need to create variable for these two
	//which we do so in lines 21 and 22 that reads private var _redBoard:RedBoard; and private var _snow:Snow;
	// then we can copy lines 36 - 58, paste beginning on line 61 and also beginning on line 73
		// replace all i with k  for 61 and change the _boarder to _redBoarder and etc.. and replace i with l for 73 and change the _blueboard to _redboard and etc..
			//this create instances with the new graphic types (snow and redBoard)
//on line 59 and 60  _cardX = 45; and 	_cardY += _card.height + 50;
	//sets the second set of cards back at 45 pixels but moves them down 50 pixels the length of the card height from the previous row
	//now we need to chang the 2 to 4 on line 26 because there are 4 sets of cards instead of 2 previously
	
//starts 9-11
//Now we need to randomize the cards to make it more challenging to find matches
//private var _cards:Array;
	//the data type of the cards will be held in an Array so we create a variable
//line 27  _cards = new Array();
	//creates a new array
// _cards.push(_card);
	//we found the first for loop (which is i) added this code to add a card at the top of the array
	//we then copy this code and paste it for the j, k and l loops (so this code should be on lines 48, 61, 75 and 88)
	
//lines 122 -140	
	//adding this block of codes under the checkCard event handler, randomizes the cards
	//private function randomizeCards(cards:Array):void
		//receives our cards so we can randomized them
	//the variables for lines 124 -127
		//create variables to hold two randowm cards and swap the X and Y positions
	//for(var i:Number = 0; i < 10; i++)
		//loop is created so that we will be able to continue to swap the x and y position of the cards
		//10 means it will randomize it up to 10 times
	//randomCard1 = Math.floor(Math.random() * cards.length); and  randomCard2 = Math.floor(Math.random() * cards.length);
		//rounds down which will give us a random of our array
	//card1X = cards[randomCard1].x; and  card1Y = cards[randomCard1].y;
		//the initial positions of the X and Y
	//cards[randomCard1].x = cards[randomCard2].x;
		//sets the randomCard 1 to the randomCard2 x position
	//cards[randomCard1].y = cards[randomCard2].y;
		//sets the randomCard 1 to the randomCard2 y position
	//randomizeCards(_cards);
		//calls our randomizeCards method
		//_cards passes our cards Array so that the cards will come out random
		
	
	